#!/bin/bash
### BEGIN INIT INFO
# Provides:          firmwareUpdate.sh
# Required-Start:    $remote_fs $syslog
# Required-Stop:     $remote_fs $syslog
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: Update Kingston SSD firmware.
# Description:       Update Kingston SSD firmware if needed.
### END INIT INFO

NEW_VERSION="608ABBF0"
OLD_VERSION="605ABBF2"
FIRMWARE="/usr/share/kingston/33513_fw.vic"
LOG="/var/log/kingston.log"
FLAG_FILE=/tmp/kingston_firmware_was_updated


CURRENT_FIRMWARE=`sudo hdparm -I /dev/sda | grep Firmware | cut -c22-29`
echo "Current SSD Firmware: $CURRENT_FIRMWARE"

if [ $CURRENT_FIRMWARE == 605ABBF2 ]; then
	echo "Updating SSD Firmware to 608ABBF0" | tee -a $LOG
	sudo hdparm --fwdownload-mode7 $FIRMWARE --yes-i-know-what-i-am-doing --please-destroy-my-drive /dev/sda
	UPDATED_FIRMWARE=`sudo hdparm -I /dev/sda | grep Firmware | cut -c22-29`
	TIMESTAMP=$(date +"%d-%b-%Y-%T")
	echo "$TIMESTAMP - SSD Firmware Updated to: $UPDATED_FIRMWARE" | tee -a $LOG
  # Since we don't know if the firmware is loaded immediately or if it requires a
  # reboot, also set a flag to sleep after this first firmware load
  touch $FLAG_FILE
elif [ $CURRENT_FIRMWARE == 608ABBF0 ]; then
	echo "SSD Firmware Already Up to Date"
fi
